<!-- Copyright (c) Vincent Dardel, <vindarez@mailz.org>,  Abelujo Developers-->
<!-- See the COPYRIGHT file at the top-level directory of this distribution-->
<!-- Abelujo is free software: you can redistribute it and/or modify-->
<!-- it under the terms of the GNU Affero General Public License as published by-->
<!-- the Free Software Foundation, either version 3 of the License, or-->
<!-- (at your option) any later version.-->
<!-- Abelujo is distributed in the hope that it will be useful,-->
<!-- but WITHOUT ANY WARRANTY; without even the implied warranty of-->
<!-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the-->
<!-- GNU Affero General Public License for more details.-->
<!-- You should have received a copy of the GNU Affero General Public License-->
<!-- along with Abelujo.  If not, see <http://www.gnu.org/licenses/>.-->

{% extends "base.html" %}
{% block auto_command_nb %} {{ auto_command_nb }} {% endblock %}
{% load staticfiles %}
{% block content %}
{% load i18n %}
{% load bootstrap3 %}
{% bootstrap_css %}
{% bootstrap_javascript %}
{% load ngfilter %}

<div ng-cloak="ng-cloak" ng-controller="collectionController">
  <div id="data-currency" data-currency="{{ currency }}"> </div>

  {% if messages %}
  <ul class="messages">{% for msg in messages %}
    <uib-alert type="{{ msg.tags }}">{{ msg }}</uib-alert>{% endfor %}
  </ul>
  {% endif %}

  <div>
    <uib-alert ng-repeat="alert in alerts" type="{{ 'alert.level' | ng }}" close="closeAlert($item)" ng-click="closeAlert($item)">
      {{ 'alert.message' | ng }}
    </uib-alert>
  </div>

  <form ng-submit="validate()">
    <div class="row">
      <form>
        <div class="col-md-6">

          <div class="form-group">
            <label class="col-md-4">{% trans "Search terms" %}</label>
            <div class="col-md-8">
              <input id="default-input" ng-model="query" type="text" placeholder="{% trans "Search on title, authors or isbn" %}" class="form-control"/>
            </div>
          </div>

          <div>
            <label class="col-sm-4">{% trans "Type of card" %}</label>
            <div class="col-md-8">
              <select ng-model="card_type" ng-options="type.fields.name for type in card_types" class="form-control"></select>
            </div>
          </div>

          <div>
            <label class="col-sm-4">{% trans "Publisher" %}</label>
            <div class="col-md-8">
              <input id="publisher-input" type="text" list="publisher-select" class="form-control"/>
              <datalist id="publisher-select">
                {% for it in publishers %}
                <option value="{{ it.name_ascii }}" id="{{ it.pk }}"></option>
                {% endfor %}
              </datalist>
            </div>
          </div>

          <div>
            <label class="col-sm-4">{% trans "Distributor" %}</label>
            <div class="col-md-8">
              <input id="distributor_input" type="text" list="distributor_select" title="Sélectionner un distributeur." class="form-control"/>
              <datalist id="distributor_select">
                {% for it in distributors %}
                <option value="{{ it.name_ascii }}" id="{{ it.id }}"></option>
                {% endfor %}
              </datalist>
            </div>
          </div>
          {% if  show_places %}
          <div class="form-group">
            <label class="col-sm-4">{% trans "Place" %}</label>
            <div class="col-md-8">
              <select ng-model="place" ng-options="elt.name for elt in places" class="form-control"></select>
            </div>
          </div>
          {% endif %}
        </div>

        <div class="col-md-6">
          <div class="form-group">
            <label class="col-sm-4">{% trans "Shelf" %}</label>
            <div class="col-md-8">
              <select ng-model="shelf" ng-options="elt.fields.name for elt in shelfs" class="form-control"></select>
            </div>
          </div>

          <div class="form-group">
            <label class="col-sm-4">{% trans "Quantity" %}</label>
            <div class="col-md-8">
              <select ng-model="quantity_choice" ng-options="elt.name for elt in quantity_choices" class="form-control"></select>
            </div>
          </div>

          <div>
            <label class="col-sm-4">{% trans "Price" %}</label>
            <div class="col-md-8">
              <select ng-model="price_choice" ng-options="elt.name group by elt.group for elt in price_choices" class="form-control"></select>
            </div>
          </div>

          <div>
            <label class="col-sm-4">{% trans "Creation date" %}</label>
            <div class="col-md-8">
              <select ng-model="date_created_sort" ng-options="elt.name group by elt.group for elt in date_created_sort_choices" class="form-control"></select>
            </div>
            <label class="col-sm-4"></label>
            <div class="col-md-8">
              <input id="default-input" ng-model="date_created" type="text" placeholder="{% trans "exple: juin 2020" %}" class="form-control"/>
            </div>
          </div>

          <div>
            <label class="col-sm-4">{% trans "Sort order" %}</label>
            <div class="col-md-8">
              <select ng-model="order_by" ng-options="elt.name group by elt.group for elt in order_by_choices" class="form-control"></select>
            </div>
          </div>

          <input hidden="true" name="with_total_sells" value="true" data-comment="Set on the JS controller."/>
          <input type="submit" hidden="true" onsubmit="validate()"/>

        </div>
      </form>
    </div>
  </form>

  <div class="row">
    <div style="margin-top: 7px; margin-bottom: 7px" class="col-md-7">
      <input value="{% trans 'Search' %}" ng-click="validate()" type="submit" class="btn btn-primary"/>
      {% if  user.is_staff %}
      <div class="btn-group">
        <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn btn-info dropdown-toggle">{% trans "Action" %}<span class="caret"></span>
        </button>
        <ul class="dropdown-menu">
          <li><a href="#" ng-click="add_to_lists()" ng-show="selected" title="{% trans "Add the cards selected to basket(s)" %}">{% trans 'Add selection to baskets…' %}</a>
          </li>
          <li><a href="#" ng-click="set_supplier()" ng-show="selected" title="{% trans "Set the supplier for the selection" %}">{% trans 'Set supplier…' %}</a>
          </li>
          <li><a href="#" ng-click="set_shelf()" ng-show="selected" title="{% trans "Set the shelf for the selection" %}">{% trans 'Set shelf…' %}</a>
          </li>
        </ul>
      </div>
      {% endif %}

      <div class="btn-group">
        <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn btn-success dropdown-toggle">{% trans "Export" %}…<span class="caret"></span>
        </button>
        <ul class="dropdown-menu">
          <li>
            <a href="/stock/export?query={{ 'query' | ng }}&format=txt&select=selection&publisher_id={{ 'publisher_pk' | ng}}&place_id={{ 'place.id' | ng}}&card_type={{ 'card_type' | ng}}&shelf_id={{ 'shelf.pk' | ng}}&distributor_id={{ 'distributor_id' | ng}}&quantity_choice={{ 'quantity_choice.id' | ng }}" ng-show="selected" title="{% trans "Export the selection to txt" %}">{% trans 'Selection - txt' %}</a>
          </li>

          <li>
            <a href="/stock/export?query={{ 'query' | ng }}&format=csv&select=selection&publisher_id={{ 'publisher_id' | ng}}&place_id={{ 'place.id' | ng}}&card_type={{ 'card_type' | ng}}&shelf_id={{ 'shelf.pk' | ng}}&distributor_id={{ 'distributor_id' | ng}}&quantity_choice={{ 'quantity_choice.id' | ng }}&date_created_sort={{ 'date_created_sort.id' | ng }}&date_created={{ 'date_created' | ng }}"
                ng-show="selected"
                title="{% trans "Export the selection to csv" %}">
              {% trans 'Selection - csv' %}
            </a>
          </li>

          <li>
            <a
                type="button"
                data-toggle="modal"
                data-target="#sellDatesModal"
                id="sellDatesButton"
                ng-show="selected"
                class="mouse-pointer"
                title="{% trans "Export the selection to csv" %}">
              {% trans "Sells" as text_sells %}
              {% trans 'Selection - csv' %} & {{ text_sells | lower }}…
            </a>
          </li>

          <!--li.divider(role="separator")-->
        </ul>
      </div>

      <div class="btn-group">
        <button ng-click="toggle_images()" title="{% trans "Hide and show covers" %}" class="btn btn-default"><i class="glyphicon glyphicon-th-list"></i>
        </button>
        <a role="button" href="http://abelujo.cc/docs/view_stock/" target="_blank" title="{% trans "Read the documentation" %}" class="btn btn-default"><i class="glyphicon glyphicon-question-sign"></i></a>
      </div><span>&nbsp;

        {% if  user.is_staff %}
        <a href="{% url 'card_create_manually' %}">{% trans "Add a card manually" %}</a>
        {% endif %}</span>
    </div>
  </div>

  <div class="col-md-7">
    <div class="btn-group"><span aria-label="page navigation" class="text-right">
      <ul ng-show="cards.length" class="pagination">
        <li class="page-item">
          <a ng-click="firstPage()" class="page-link">&laquo;</a>
        </li>
        <li class="page-item">
          <a ng-click="previousPage()" class="page-link"><</a>
        </li>
        <li class="page-item">
          <a class="page-link">Page {{ 'page' | ng }} / {{ 'meta.num_pages' | ng }} ({{ 'meta.nb_results' | ng }})</a>
        </li>
        <li class="page-item">
          <a ng-click="nextPage()" class="page-link">></a>
        </li>
        <li class="page-item">
          <a ng-click="lastPage()" class="page-link">&raquo;</a>
        </li>
      </ul></span>
    </div>

    <div class="btn-group">
      <select ng-show="cards.length" ng-model="page_size" ng-options="it for it in page_sizes" style="width: 5em" class="form-control"></select>
    </div>
    <div id="message" ng-show="meta.message" ng-class="meta.message_status">{{ 'meta.message' | ng }}</div>
  </div>
  <div ng-show="! first_page_load && cards.length == 0 ">{% trans "No results" %}</div>

  <table ng-show="cards.length != 0" class="row-border hover table table-condensed table-striped">
    <thead>
      <th>
        <input type="checkbox" ng-click="toggleAll()"/>
      </th>
      <th ng-show="show_images"></th>
      <th>{% trans "Title" %}</th>
      <th>{% trans "Price" %}</th>
      <th>{% trans "Authors" %}</th>
      <th>{% trans "Publishers" %}</th>
      <th>{% trans "Supplier" %}</th>
      <th>{% trans "Shelf" %}</th>
      <th>{% trans "Quantity" %}</th>
      <th>{% trans "In deposits" %}</th>
      <th>{% trans "Places" %}</th>
      <th></th>
    </thead>

    <tbody>
      <tr ng-repeat="card in cards">
        <td>
          <input type="checkbox" ng-model="selected[card.id]"/>
        </td>
        <td ng-show="show_images">
          <div ng-show="show_images" class="col-md-6">

            <!-- Click to enlarge image. -->
            <a data-toggle="modal"
                data-target="#enlargeImageModal{{ 'card.id' | ng }}"
	        title="{% trans 'Enlarge image' %}">
              <img ng-show="card.img" ng-src="{{ 'card.img' | ng }}" class="myImg mouse-pointer" alt="cover image"/>
            </a>
          </div>

          <!-- enlargeImageModal ci-dessous: -->
          <div id="enlargeImageModal{{ 'card.id' | ng }}" class="modal">
            {% include "search/modale_enlarge_image_body.html" %}
          </div>

</div>

        </td>
        <td>
          <div class="row">
            <div class="col-md-9">
              <div>
                <a href="{{ 'card.get_absolute_url' | ng }}">{{ 'card.title' | ng }}</a>
              </div>
              <h6 ng-show="show_images">
                <a ng-show="card.details_url" href="{{ 'card.details_url' | ng }}" target="_blank">{% trans "See on" %} {{ 'card.data_source' |ng}}</a>
              </h6>
              <div ng-show="show_images" class="row">
                <div class="col-md-10"><b>isbn: </b><span>{{ 'card.isbn' |ng}}</span>
                  <div>{% trans "Publication date" %}: {{ 'card.date_publication | date: "mediumDate"' | ng }}</div>
                  <div title="{% trans "Date de dernière modification, par exemple la date du dernier ajout en stock." %}">{% trans "Dernière modification" %}: {{ 'card.modified | date: "mediumDate"' | ng }}</div>
                  <div ng-show="show_images && card.fmt">{{ 'card.fmt' | ng }}</div>
                </div>
              </div>
            </div>
          </div>
        </td>
        <td>
          <div>{{ 'card.price_fmt' | ng}}</div>
        </td>
        <td>
          <div>{{ 'card.authors_repr' | ng }}</div>
        </td>
        <td>{{ 'card.pubs_repr' | ng }}</td>
        <td>{{ 'card.distributor_repr' | ng }}</td>
        <td>
          <div class="badge badge-secondary">{{ 'card.shelf' | ng }}</div>
        </td>
        <td class="text-right">
          <div>{{ 'card.quantity' | ng }}</div>
          <div ng-show="card.total_copies_sold" title="{% trans "Total number of copies sold, all time." %}">{% trans "sold" %}: {{ 'card.total_copies_sold' | ng }}</div>
        </td>
        <td class="text-right">{{ 'card.qty_deposits' | ng }}</td>
        <td>
          <div ng-show="card.places">{{ 'card.places' | ng }}</div>
        </td>
        <td>
          <button type="button" data-toggle="modal" data-target="#reserveModal" id="{{ 'card.isbn' | ng }}" title="Réserver pour un client" onclick="save_isbn_for_reservation(this.id)" class="btn btn-default"><i class="glyphicon glyphicon-user"></i>
          </button>
          <a title="{% trans "Remember to command this card. Add it to the list for later." %}" ng-click="do_card_command(card.id)" class="btn btn-warning"><i class="glyphicon glyphicon-shopping-cart"></i><span>&nbsp; x<span id="command{{ 'card.id' | ng }}">{{ 'card.quantity_in_command' | ng }}</span></span></a>
        </td>
      </tr>
    </tbody>
  </table>

  <div class="col-md-7">
    <div class="btn-group"><span aria-label="page navigation" class="text-right">
      <ul ng-show="cards.length" class="pagination">
        <li class="page-item">
          <a ng-click="firstPage()" class="page-link">&laquo;</a>
        </li>
        <li class="page-item">
          <a ng-click="previousPage()" class="page-link"><</a>
        </li>
        <li class="page-item">
          <a class="page-link">Page {{ 'page' | ng }} / {{ 'meta.num_pages' | ng }} ({{ 'meta.nb_results' | ng }})</a>
        </li>
        <li class="page-item">
          <a ng-click="nextPage()" class="page-link">></a>
        </li>
        <li class="page-item">
          <a ng-click="lastPage()" class="page-link">&raquo;</a>
        </li>
      </ul></span>
    </div>

    <div class="btn-group">
      <select ng-show="cards.length" ng-model="page_size" ng-options="it for it in page_sizes" style="width: 5em" class="form-control"></select>
    </div>
  </div>

  <script type="text/ng-template" id="collectionModal.html">
    <div class="modal-header">
      <h3 class="modal-title">{% trans "Add to basket(s)" %}</h3>
    </div>
    <div class="modal-body">
      <div ng-repeat="basket in baskets"><span>
        <input type="checkbox" ng-model="selected_baskets[basket.id]"/>
        <label>{{ 'basket.name' | ng}}</label></span>
      </div>
      <button ng-click="ok()" class="btn btn-primary">OK</button>
    </div>
  </script>

  <!-- Select two dates. Uses the collection controller. -->
  <div id="sellDatesModal" class="modal">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <h4 class="modal-title"> {% trans "Dates" %} </h4>
          <span>
            {% trans "Add a column that counts the number of sells between two dates." %}
            {% trans "Specially useful for deposits that we contain in shelves." %}
          </span>
          <button type="button" data-dismiss="modal" class="close"></button>
        </div>
        <div class="modal-body">
          <form>
            <p class="input-group">
              <input type="text"
                  uib-datepicker-popup="{{"format"|ng}}"
                  ng-model="dateStart"
                  ng-required="true"
                  is-open="opened"
                  datepicker-options="dateOptions"
                  close-text="Close"
                  tabindex="5"
                  class="form-control"/>
	      <span class="input-group-btn">
                <button type="button" ng-click="open($event)" class="btn btn-default">
	          <i class="glyphicon glyphicon-calendar">
	          </i>
                </button>
	      </span>

              <input type="text"
                  uib-datepicker-popup="{{'format'|ng}}"
                  ng-model="dateEnd"
                  is-open="opened"
                  datepicker-options="dateOptions"
                  ng-required="true"
                  close-text="Close"
                  tabindex="5"
                  class="form-control"/>
	      <span class="input-group-btn">
                <button type="button" ng-click="open($event)" class="btn btn-default">
	          <i class="glyphicon glyphicon-calendar">
	          </i>
                </button>
	      </span>
            </p>

           </span></span> <button type="button" ng-click="export_with_sells()" class="btn btn-success">
              {% trans "Export" %}
            </button>

          </form>
        </div>
      </div>
    </div>
  </div>

</div>

<!-- ! Copied from searchresults, copied from elsewhere :(-->
<div id="reserveModal" class="modal">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <h4 class="modal-title">Réserver</h4>
        <button type="button" data-dismiss="modal" class="close"></button>
      </div>
      <div class="modal-body">
        <h5>{% trans "Clients" %}</h5>
        <input id="clients-input" list="clients-select" onkeydown="if (event.keyCode == 13) validate_reservation()"/>

        <datalist id="clients-select">
          {% for client in clients %}
          <option value="{{ client.repr }}" id="{{ client.id }}"></option>
          {% endfor %}
        </datalist>

        <button type="button" onclick="validate_reservation()" class="btn btn-success">OK</button><br/>{% if  reservations %}
        <h5>{% trans "Ces clients ont réservé cette notice" %}:</h5>
        <table class="table table-condensed">
          {% for resa in reservations %}
          <tr id="#resa-{{ resa.client.id }}">
            <td>
              <h4>{{ resa.client.repr }} &nbsp;
                <a href="{{ resa.client.url }}" target="_blank"><i class="glyphicon glyphicon-share"></i></a>
              </h4>
            </td>
            <td>{% if  resa.client.mobilephone %}<span>{{ resa.client.mobilephone }} <i class="glyphicon glyphicon-phone"></i></span>{% endif %}
            </td>
            <td>
              <button type="button" onclick="cancel_reservation({{ resa.client.id }})" name="cancel-reservation" alt="Cancel reservation"><i class="glyphicon glyphicon-remove"></i>
              </button>
            </td>
          </tr>
          {% endfor %}
        </table>
        {% endif %}

      </div>
    </div>
  </div>
</div>

<!-- for save_isbn_for_reservation-->
<!-- important to run this last, so CSS selectors select something.-->
<script type="text/javascript" src="{% static 'search/js/card.js' %}"></script>
{% endblock content %}
